diff a/src/jdk.compiler/share/classes/com/sun/tools/javac/processing/PrintingProcessor.java b/src/jdk.compiler/share/classes/com/sun/tools/javac/processing/PrintingProcessor.java
--- a/src/jdk.compiler/share/classes/com/sun/tools/javac/processing/PrintingProcessor.java
+++ b/src/jdk.compiler/share/classes/com/sun/tools/javac/processing/PrintingProcessor.java
@@ -500,16 +500,19 @@
                 break;
 
             case METHOD:
             case FIELD:
                 Element enclosingElement = e.getEnclosingElement();
-                if (enclosingElement != null &&
-                    enclosingElement.getKind().isInterface()) {
-                    modifiers.remove(Modifier.PUBLIC);
-                    modifiers.remove(Modifier.ABSTRACT); // only for methods
-                    modifiers.remove(Modifier.STATIC);   // only for fields
-                    modifiers.remove(Modifier.FINAL);    // only for fields
+                if (enclosingElement != null) {
+                    if (enclosingElement.getKind().isInterface()) {
+                        modifiers.remove(Modifier.PUBLIC);
+                        modifiers.remove(Modifier.ABSTRACT); // only for methods
+                        modifiers.remove(Modifier.STATIC);   // only for fields
+                        modifiers.remove(Modifier.FINAL);    // only for fields
+                    } else if (enclosingElement.getKind() == RECORD) {
+                        modifiers.remove(Modifier.STRICTFP);
+                    }
                 }
                 break;
 
             }
             if (!modifiers.isEmpty()) {
